import es, gamethread, playerlib, popuplib, string

''' Effects:
1. smoke
2. energy
3. beam
4. sparks
5. beacon - Requires es_tools.
'''

###START EDITING###

# HE Grenade effect.
he_effect = es.ServerVar("he_effect", "smoke")

# Flashbang effect.
fb_effect = es.ServerVar("fb_effect", "energy")

# Smoke grenade effect.
sg_effect = es.ServerVar("sg_effect", "beam")

###STOP EDITING###

es.server.cmd("eventscripts_noisy 1")
es.ServerVar("nadetrail_ver", "1.1", "The version of NadeTrail you are running!")
beam_location_he = {}
beam_location_fb = {}
beam_location_sg = {}
energy_location_he = {}
energy_location_fb = {}
energy_location_sg = {}
sparks_location_he = {}
sparks_location_fb = {}
sparks_location_sg = {}

def load():
    setup_effects()

def es_map_start(event_var):
    setup_effects()

def setup_effects():
    global beam
    global beam_location_he
    global beam_location_fb
    global beam_location_sg
    global energy_location_he
    global energy_location_fb
    global energy_location_sg
    global sparks_location_he
    global sparks_location_fb
    global sparks_location_sg
    beam = es.precachemodel("sprites/crystal_beam1.vmt")
    for nt_userid in playerlib.getPlayerList("#all"):
        beam_location_he[int(nt_userid)] = None
        beam_location_sg[int(nt_userid)] = None
        beam_location_fb[int(nt_userid)] = None
        energy_location_he[int(nt_userid)] = None
        energy_location_sg[int(nt_userid)] = None
        energy_location_fb[int(nt_userid)] = None
        sparks_location_he[int(nt_userid)] = None
        sparks_location_sg[int(nt_userid)] = None
        sparks_location_fb[int(nt_userid)] = None

def player_activate(event_var):
    global beam_location_he
    global beam_location_fb
    global beam_location_sg
    global energy_location_he
    global energy_location_fb
    global energy_location_sg
    global sparks_location_he
    global sparks_location_fb
    global sparks_location_sg
    beam_location_he[int(event_var["userid"])] = None
    beam_location_sg[int(event_var["userid"])] = None
    beam_location_fb[int(event_var["userid"])] = None
    energy_location_he[int(event_var["userid"])] = None
    energy_location_sg[int(event_var["userid"])] = None
    energy_location_fb[int(event_var["userid"])] = None
    sparks_location_he[int(event_var["userid"])] = None
    sparks_location_sg[int(event_var["userid"])] = None
    sparks_location_fb[int(event_var["userid"])] = None

def round_start(event_var):
    for nt_userid in playerlib.getPlayerList("#all"):
        gamethread.cancelDelayed("s_he_%s" % nt_userid)
        gamethread.cancelDelayed("s_sg_%s" % nt_userid)
        gamethread.cancelDelayed("s_fb_%s" % nt_userid)

def unload():
    for nt_userid in playerlib.getPlayerList("#all"):
        gamethread.cancelDelayed("s_he_%s" % nt_userid)
        gamethread.cancelDelayed("s_sg_%s" % nt_userid)
        gamethread.cancelDelayed("s_fb_%s" % nt_userid)

def weapon_fire(event_var):
    if event_var["weapon"] == "hegrenade":
        gamethread.delayed(0.15, getentity, args=(event_var["userid"], 1))
    if event_var["weapon"] == "flashbang":
        gamethread.delayed(0.15, getentity, args=(event_var["userid"], 2))
    if event_var["weapon"] == "smokegrenade":
        gamethread.delayed(0.15, getentity, args=(event_var["userid"], 3))

def getentity(nt_userid, nt_type):
    nt_player = es.getplayerhandle(nt_userid)
    if nt_type == 1:
        nt_list = es.createentitylist("hegrenade_projectile")
    if nt_type == 2:
        nt_list = es.createentitylist("flashbang_projectile")
    if nt_type == 3:
        nt_list = es.createentitylist("smokegrenade_projectile")
    for nt_temp in nt_list:
        if nt_player == es.getindexprop(nt_temp, "CBaseGrenade.m_hThrower"):
            effect(nt_userid, nt_temp, int(nt_type))

def effect(nt_userid, nt_entity, nt_type):
    global beam_location_he
    global beam_location_fb
    global beam_location_sg
    if nt_type == 1:
        nt_format = "s_he_%s" % nt_userid
        nt_effect = he_effect
    if nt_type == 2:
        nt_format = "s_fb_%s" % nt_userid
        nt_effect = fb_effect
    if nt_type == 3:
        nt_format = "s_sg_%s" % nt_userid
        nt_effect = sg_effect
    if nt_effect == "smoke":
        effect_smoke(nt_entity)
    if nt_effect == "beacon":
        effect_beacon(nt_userid, nt_entity)
    if nt_effect == "sparks":
        if nt_type == 1:
            sparks_location_he[int(nt_userid)] = effect_sparks(nt_entity, sparks_location_he[int(nt_userid)])
        if nt_type == 2:
            sparks_location_fb[int(nt_userid)] = effect_sparks(nt_entity, sparks_location_fb[int(nt_userid)])
        if nt_type == 3:
            sparks_location_sg[int(nt_userid)] = effect_sparks(nt_entity, sparks_location_sg[int(nt_userid)])
    if nt_effect == "beam":
        if nt_type == 1:
            beam_location_he[int(nt_userid)] = effect_beam(nt_entity, beam_location_he[int(nt_userid)])
        if nt_type == 2:
            beam_location_fb[int(nt_userid)] = effect_beam(nt_entity, beam_location_fb[int(nt_userid)])
        if nt_type == 3:
            beam_location_sg[int(nt_userid)] = effect_beam(nt_entity, beam_location_sg[int(nt_userid)])
    if nt_effect == "energy":
        if nt_type == 1:
            energy_location_he[int(nt_userid)] = effect_energy(nt_entity, energy_location_he[int(nt_userid)])
        if nt_type == 2:
            energy_location_fb[int(nt_userid)] = effect_energy(nt_entity, energy_location_fb[int(nt_userid)])
        if nt_type == 3:
            energy_location_sg[int(nt_userid)] = effect_energy(nt_entity, energy_location_sg[int(nt_userid)])
    gamethread.delayedname(0.01, nt_format, effect, args=(nt_userid, nt_entity, nt_type))

def effect_smoke(nt_entity):
    nt_location = es.getindexprop(nt_entity, "CBaseEntity.m_vecOrigin")
    es.effect("smoke", nt_location, "smoke", 5, 0.1)

def effect_beam(nt_entity, nt_oldlocation):
    nt_location = es.getindexprop(nt_entity, "CBaseEntity.m_vecOrigin")
    if nt_oldlocation == None:
        nt_oldlocation = nt_location
    es.effect("beam", nt_oldlocation, nt_location, beam, beam, 0, 0, 0.7, 10, 10, 0.5, 1, 255, 255, 255, 255, 30)
    return nt_location

def effect_energy(nt_entity, nt_oldlocation):
    nt_location = es.getindexprop(nt_entity, "CBaseEntity.m_vecOrigin")
    if nt_oldlocation == None:
        nt_oldlocation = nt_location
    es.effect("energysplash", nt_oldlocation, nt_location, 0)
    return nt_location

def effect_sparks(nt_entity, nt_oldlocation):
    nt_location = es.getindexprop(nt_entity, "CBaseEntity.m_vecOrigin")
    if nt_oldlocation == None:
        nt_oldlocation = nt_location
    es.effect("sparks", nt_oldlocation, 1, 5, nt_location)
    return nt_location

def effect_beacon(nt_userid, nt_entity):
    nt_location = es.getindexprop(nt_entity, "CBaseEntity.m_vecOrigin")
    (nt_x, nt_y, nt_z) = es.splitvectorstring(nt_location)
    es.server.cmd('est_effect 10 #all 0 "sprites/lgtning.vmt" %s %s %s 0 50 1 1 1 1 0 255 0 255 0' % (nt_x, nt_y, nt_z))

def hegrenade_detonate(event_var):
    gamethread.cancelDelayed("s_he_%s" % event_var["userid"])
    global beam_location_he
    global energy_location_he
    global sparks_location_he
    beam_location_he[int(event_var["userid"])] = None
    energy_location_he[int(event_var["userid"])] = None
    sparks_location_he[int(event_var["userid"])] = None

def smokegrenade_detonate(event_var):
    gamethread.cancelDelayed("s_sg_%s" % event_var["userid"])
    global beam_location_sg
    global energy_location_sg
    global sparks_location_sg
    beam_location_sg[int(event_var["userid"])] = None
    energy_location_sg[int(event_var["userid"])] = None
    sparks_location_sg[int(event_var["userid"])] = None

def flashbang_detonate(event_var):
    gamethread.cancelDelayed("s_fb_%s" % event_var["userid"])
    global beam_location_fb
    global energy_location_fb
    global sparks_location_fb
    beam_location_fb[int(event_var["userid"])] = None
    energy_location_fb[int(event_var["userid"])] = None
    sparks_location_fb[int(event_var["userid"])] = None

def player_say(event_var):
    if event_var["text"].lower() == "!nadetrail":
        help(event_var["userid"])

def help(nt_userid):
    if popuplib.isqueued('p_help', nt_userid):
        popuplib.close('p_help', nt_userid)
    p_help = popuplib.create("p_help")
    p_help.addline("-NadeTrail-")
    p_help.addline("-------------------")
    p_help.addline("Author: JoeyT2008")
    p_help.addline("Version: 1.1")
    p_help.addline("HE Grenade: %s" % he_effect)
    p_help.addline("FlashBang: %s" % fb_effect)
    p_help.addline("Smoke Grenade: %s" % sg_effect)
    p_help.addline("-------------------")
    p_help.addline("0. Close")
    p_help.send(nt_userid)
